<?php
session_start();

function DisplayHeader() {
	echo "<html>\n";
	echo "<head>\n";
	echo "<title>AmboStats WebInstaller</title>\n";
	echo "</head>\n";
	echo "<body bgcolor=\"#CCCCCC\">\n";
}
function DisplayFooter() {
	echo "</body>\n";
	echo "</html>";
}
function DisplayError($MyError) {
	DisplayHeader();
	echo "<table width=\"100%\" height=\"100%\" border=\"0\" cellspacing=\"0\" cellpadding=\"0\">\n";
	echo "<tr>\n";
	echo "<td valign=\"middle\" align=\"center\">\n";
	echo "<table width=\"450\" border=\"0\" bgcolor=\"#FFFFFF\" cellspacing=\"0\" cellpadding=\"5\" align=\"center\" style=\"border: medium double rgb(250,0,255)\">\n";
	echo "<tr>\n";
	echo "<td>$MyError</td>\n";
	echo "</tr>\n";
	echo "</table>\n";
	echo "</td>\n";
	echo "</tr>\n";
	echo "</table>\n";
	DisplayFooter();
}
function DisplayMySQLForm($MyError = "") {
	DisplayHeader();
	
	$mysqlserver = $_POST["mysqlserver"] ? $_POST["mysqlserver"] : 'localhost';
	$prefix = $_POST["mysqlprefix"] ? $_POST["mysqlprefix"] : 'Ambo';
	echo "<form action=\"installer.php?step=2\" method=\"post\">\n";
	echo "<table width=\"450\" border=\"0\" cellspacing=\"0\" cellpadding=\"5\" bgcolor=\"#FFFFFF\" align=\"center\">\n";
	echo "<tr>\n";
	echo "<td colspan=\"2\"><b>Step 1</b> : MySQL data <font color=\"red\">$MyError</font></td>\n";
	echo "</tr>\n";
	echo "<tr>\n";
	echo "<td colspan=\"2\">Please fill out the settings of your MySQL database. AmboStats only works with such a database</td>\n";
	echo "</tr>\n";
	echo "<tr>\n";
	echo "<td colspan=\"2\">&nbsp;</td>\n";
	echo "</tr>\n";
	echo "<tr>\n";
	echo "<td><b>Server</b></td>\n";
	echo "<td><input type=\"text\" name=\"mysqlserver\" value=\"$mysqlserver\"></td>\n";
	echo "</tr>\n";
	echo "<tr>\n";
	echo "<td><b>Username</b></td>\n";
	echo "<td><input type=\"text\" name=\"mysqluser\" value=\"{$_POST["mysqluser"]}\"></td>\n";
	echo "</tr>\n";
	echo "<tr>\n";
	echo "<td><b>Password</b></td>\n";
	echo "<td><input type=\"text\" name=\"mysqlpass\" value=\"{$_POST["mysqlpass"]}\"></td>\n";
	echo "</tr>\n";
	echo "<tr>\n";
	echo "<td><b>Database</b></td>\n";
	echo "<td><input type=\"text\" name=\"mysqldb\" value=\"{$_POST["mysqldb"]}\"></td>\n";
	echo "</tr>\n";
	echo "<tr>\n";
	echo "<td><b>Table-prefix</b></td>\n";
	echo "<td><input type=\"text\" name=\"mysqlprefix\" value=\"$prefix\"></td>\n";
	echo "<tr>\n";
	echo "<td colspan=\"2\" align=\"right\"><input type=\"submit\" name=\"submit\" value=\"Proceed\"></td>\n";
	echo "</tr>\n";
	echo "</table>\n";
	echo "</form>\n";
	DisplayFooter();
}

function DisplaySettingsForm($MyError = "") {
	DisplayHeader();
	
	echo "<form action=\"installer.php?step=3\" method=\"post\">\n";
	echo "<table width=\"450\" border=\"0\" cellspacing=\"0\" cellpadding=\"5\" bgcolor=\"#FFFFFF\" align=\"center\">\n";
	echo "<tr>\n";
	echo "<td colspan=\"2\"><b>Step 2</b> : Account information <font color=\"red\">$MyError</font></td>\n";
	echo "</tr>\n";
	echo "<tr>\n";
	//echo "<td colspan=\"2\">Supply a username and password to create an administrator account. You will need this account to change settings.</td>\n";
	echo "<td colspan=\"2\">You are about to create an administrator user to manage AmboStats.</td>\n";
	echo "</tr>\n";
	echo "<tr>\n";
	echo "<td colspan=\"2\">&nbsp;</td>\n";
	echo "</tr>\n";
	echo "<tr>\n";
	echo "<td><b>Username</b></td>\n";
	echo "<td><input type=\"text\" name=\"username\" value=\"{$_POST["username"]}\">\n";
	echo "</tr>\n";
	echo "<tr>\n";
	echo "<td><b>Password</b></td>\n";
	echo "<td><input type=\"password\" name=\"password1\">\n";
	echo "</tr>\n";
	echo "<tr>\n";
	echo "<td><b>Repeat password</b></td>\n";
	echo "<td><input type=\"password\" name=\"password2\">\n";
	echo "</tr>\n";
	echo "<tr>\n";
	echo "<td colspan=\"2\" align=\"right\"><input type=\"submit\" name=\"submit\" value=\"Proceed\"></td>\n";
	echo "</tr>\n";
	echo "</table>\n";
	echo "</form>\n";
	DisplayFooter();
}

$step = $_GET["step"];
switch ($step) {
	case '2':
	if (!$_POST["mysqlserver"] || !$_POST["mysqluser"] || !$_POST["mysqlpass"] || !$_POST["mysqldb"] || !$_POST["mysqlprefix"]) {
		return DisplayMySQLForm("You need to fill out all fields");
		exit;
	}
	$link = @mysql_connect($_POST["mysqlserver"], $_POST["mysqluser"], $_POST["mysqlpass"]);
	if ($link > 0) {
		$db = @mysql_select_db($_POST["mysqldb"]);
		@mysql_close($link);
		if ($db > 0) {
			$_SESSION["FGJOmysqlserver"] = $_POST["mysqlserver"];
			$_SESSION["FGJOmysqluser"] = $_POST["mysqluser"];
			$_SESSION["FGJOmysqlpass"] = $_POST["mysqlpass"];
			$_SESSION["FGJOmysqldb"] = $_POST["mysqldb"];
			$_SESSION["FGJOmysqlprefix"] = $_POST["mysqlprefix"];
			return DisplaySettingsForm();
		}
		else {
			return DisplayMySQLForm("Could not connect to the database. Is it spelled correct?");
			exit;
		}
	}
	else {
		return DisplayMySQLForm("I wasn't able to connect to the MySQL server with this information, wrong username or password?");
	}
	
	break;
	
	case '3':
	if (!$_POST["username"] || !$_POST["password1"] || !$_POST["password2"]) {
		return DisplaySettingsForm("You need to fill out all fields");
		exit;
	}
	if ($_POST["password1"] <> $_POST["password2"]) {
		return DisplaySettingsForm("Passwords need to be thesame");
		exit;
	}
	
	DisplayHeader();
	echo "<table width=\"450\" border=\"0\" cellspacing=\"0\" cellpadding=\"5\" bgcolor=\"#FFFFFF\" align=\"center\">\n";
	echo "<tr>\n";
	echo "<td>Writing config file... ";
	
	$configfile = <<<EOT
<?php
// Settings for the database
\$settings["dbserver"] = "{$_SESSION["FGJOmysqlserver"]}";
\$settings["dbuser"] = "{$_SESSION["FGJOmysqluser"]}";
\$settings["dbpass"] = "{$_SESSION["FGJOmysqlpass"]}";
\$settings["dbname"] = "{$_SESSION["FGJOmysqldb"]}";
\$settings["dbprefix"] = "{$_SESSION["FGJOmysqlprefix"]}";

// Administrator account
\$settings["adminuser"] = "{$_POST["username"]}";
\$settings["adminpass"] = "{$_POST["password1"]}";
?>
EOT;
	$fh = fopen("config.inc.php","w");
	fputs($fh,$configfile);
	fclose($fh);
	
	echo "<b>done!</b></td>\n";
	echo "</tr>\n";
	echo "<tr>\n";
	echo "<td>Creating table Servers... ";
	
	require("config.inc.php");
	require("lib.inc.php");
	
	$link = DBconnect();
	$query = "CREATE TABLE `{$_SESSION["FGJOmysqlprefix"]}Servers` (
	         `ServerID` int(11) NOT NULL auto_increment,
	         `ServerCode` varchar(30) NOT NULL default '',
	         `ServerIP` varchar(20) NOT NULL default '',
	         `ServerStatus` int(11) NOT NULL default '0',
	         `ServerDedicated` enum('True','False') NOT NULL default 'True',
	         `ServerGameType` varchar(10) NOT NULL default '',
	         `ServerName` varchar(50) NOT NULL default '',
	         `ServerMaxPlayers` int(11) NOT NULL default '0',
	         `ServerCurrentPlayers` int(11) NOT NULL default '0',
	         `ServerCurrentMap` varchar(255) NOT NULL default '',
	         `ServerCountryCode` char(2) default NULL,
	         `ServerPlayers` text,
	         `ServerTeams` text,
	         `ServerMessage` text,
	         `ServerLastUpdate` datetime NOT NULL default '0000-00-00 00:00:00',
	         PRIMARY KEY  (`ServerID`),
	         UNIQUE KEY `ServerCode` (`ServerCode`)
	         ) TYPE=MyISAM";

	$result = mysql_query($query) or die(mysql_error());
	
	echo "<b>done!</b></td>\n";
	echo "</tr>\n";
	echo "<tr>\n";
	echo "<td>Creating table Players... ";
	
	$query = "CREATE TABLE `{$_SESSION["FGJOmysqlprefix"]}Players` (
	         `PlayerID` bigint(20) NOT NULL auto_increment,
	         `PlayerName` varchar(100) NOT NULL default '',
	         `LastPlayed` datetime NOT NULL default '0000-00-00 00:00:00',
	         `SdAdFriendlyZoneDefendKills` bigint(20) NOT NULL default '0',
               `SdAdFriendlyZonePolicingKills` bigint(20) NOT NULL default '0',
               `SdAdEnemyZoneAttackKills` bigint(20) NOT NULL default '0',
               `SdAdEnemyZoneSecuringKills` bigint(20) NOT NULL default '0',
               `Murders` bigint(20) NOT NULL default '0',
	         `Kills` bigint(20) NOT NULL default '0',
	         `Deaths` bigint(20) NOT NULL default '0',
	         `SecondsInZone` bigint(20) NOT NULL default '0',
	         `Targets` bigint(20) NOT NULL default '0',
	         `Suicides` bigint(20) NOT NULL default '0',
	         `ShotsFired` bigint(20) NOT NULL default '0',
	         `MedicSaves` bigint(20) NOT NULL default '0',
	         `MedicRevives` bigint(20) NOT NULL default '0',
	         `PspAttempt` bigint(20) NOT NULL default '0',
	         `PspTakes` bigint(20) NOT NULL default '0',
	         `Headshots` bigint(20) NOT NULL default '0',
	         `Knifes` bigint(20) NOT NULL default '0',
	         `SniperKills` bigint(20) NOT NULL default '0',
	         `ZoneAttackKills` bigint(20) NOT NULL default '0',
	         `ZoneDefendKills` bigint(20) NOT NULL default '0',
	         `ExpPoints` bigint(20) NOT NULL default '0',
	         `Assists` bigint(20) NOT NULL default '0',
	         `TimePlayed` bigint(20) NOT NULL default '0',
	         `TotalGames` bigint(20) NOT NULL default '0',
	         `GamesWon` bigint(20) NOT NULL default '0',
               `GamesLost` bigint(20) NOT NULL default '0',
               `GamesDraw` bigint(20) NOT NULL default '0',
	         PRIMARY KEY  (`PlayerID`),
	         UNIQUE KEY `PlayerName` (`PlayerName`)
	         ) TYPE=MyISAM";

	$result = mysql_query($query) or die(mysql_error());
	
	echo "<b>done!</b></td>\n";
	echo "</tr>\n";
	echo "<tr>\n";
	echo "<td>Creating table ImportLog... ";

      $query = "CREATE TABLE `{$_SESSION["FGJOmysqlprefix"]}ImportLog` (
               `ServerID` int(11) NOT NULL default '0',
               `ImportDate` datetime NOT NULL default '0000-00-00 00:00:00',
               PRIMARY KEY  (`ServerID`,`ImportDate`)
               ) TYPE=MyISAM";

	$result = mysql_query($query) or die(mysql_error());
	
	echo "<b>done!</b></td>\n";
	echo "</tr>\n";
	echo "<tr>\n";
	echo "<td>Creating table Maps... ";

      $query = "CREATE TABLE `{$_SESSION["FGJOmysqlprefix"]}Maps` (
               `MapID` int(11) NOT NULL auto_increment,
               `MapName` varchar(128) NOT NULL default '',
               `MapTimesHosted` bigint(20) NOT NULL default '0',
               `MapTimeHosted` bigint(20) NOT NULL default '0',
               `MapGameType` varchar(8) NOT NULL default '',
               `MapLastPlayed` datetime NOT NULL default '0000-00-00 00:00:00',
               PRIMARY KEY  (`MapID`),
               UNIQUE KEY `MapName` (`MapName`)
               ) TYPE=MyISAM";

	$result = mysql_query($query) or die(mysql_error());
	
	echo "<b>done!</b></td>\n";
	echo "</tr>\n";
	echo "<tr>\n";
	echo "<td>Creating table MapStats... ";

      $query = "CREATE TABLE `{$_SESSION["FGJOmysqlprefix"]}MapStats` (
               `MapID` int(11) NOT NULL default '0',
               `PlayerID` bigint(20) NOT NULL default '0',
               `Kills` bigint(20) NOT NULL default '0',
               `Deaths` bigint(20) NOT NULL default '0',
               `ExpPoints` bigint(20) NOT NULL default '0',
               `TimePlayed` bigint(20) NOT NULL default '0',
               `TotalGames` bigint(20) NOT NULL default '0',
               PRIMARY KEY  (`MapID`,`PlayerID`)
               ) TYPE=MyISAM";

	$result = mysql_query($query) or die(mysql_error());
	
	echo "<b>done!</b></td>\n";
	echo "</tr>\n";
	echo "<tr>\n";
	echo "<td>&nbsp;</td>\n";
	echo "</tr>\n";
	echo "<tr>\n";
	echo "<td>\n";
	echo "<b>Installation done!</b><br><br>\n";
	echo "<a href=\"admin.php\">Click here to administrate your stats</a><br>\n";
	echo "<a href=\"index.php\">Click here to view your stats page</a><br><br>\n";
	echo "<font color=\"red\">Important: remove this file (installer.php) now to make sure nobody writes to your config file!!</font>\n";
	echo "</td>\n";
	echo "</tr>\n";

	DBdisconnect($link);
	break;
	
	default:
	if (!is_writable("config.inc.php")) {
		DisplayError("&quot;config.inc.php&quot; write test failed. Make sure I can write to this file.<br><br> > CHMOD 666 config.inc.php");
		exit;
	}
	DisplayMySQLForm();
}

?>